<?php
defined('IN_PHPCMS') or exit('No permission resources.');

pc_base::load_app_class('common');
pc_base::load_sys_class('form', '', 0);
pc_base::load_app_func('global');
 
class centre  extends common
{
	public function __construct()
	{
		parent::__construct();		
	}
	//订单列表
	public function init()
	{   
		$o = pc_base::load_app_class('orders');
		$status = isset($_GET['status']) ? intval($_GET['status']) : '';

		$orders  = $o->listinfo($this->_userid, $status);
		$pages   = $o->pages;
		include template("ishop","entre_init");		
	}  
	//订单详情
	public function orderinfo()
	{
		$o		= pc_base::load_app_class('orders');
		$info	= $o->get(intval($_GET['id']));
		if(empty($info))
		{
			showmessage(L('parameters_error'),HTTP_REFERER);
		}
		//dump($info);
		include template("ishop","entre_orderinfo");			
	}

	public function address()
	{
		$address_db = pc_base::load_model('ishop_address_model');
		$address = $address_db->select(array('username'=>$this->_username));
		
		include template("ishop","entre_address");
	}  
	public function address_edit()
	{
		$address_db = pc_base::load_model('ishop_address_model');
		if($_POST['dosubmit']){     
			$address = $_POST['info'];
			$id = intval($_POST['id']);
			$address_db->update($address, "id='{$id}'");
			showmessage(L('operation_success'), "index.php?m=ishop&c=centre&a=address&t=5"); 
		}else{
			$id = intval($_GET['id']);
			
			$address = $address_db->get_one(array('id'=>$id));
			
			include template("ishop","entre_address_edit");
		}
	}
	public function address_add()
	{   
		$address_db = pc_base::load_model('ishop_address_model');
		if($_POST['dosubmit']){
			$address = $_POST['info'];
			$address['username'] = $this->_username;
			$address_db->insert($address, true);
			showmessage(L('operation_success'), "index.php?m=ishop&c=centre&a=address&t=5"); 
		}else{
			
			include template("ishop","entre_address_add");  
		}
	}
	public function address_del()
	{
		$id = intval($_GET['id']);
		$address_db = pc_base::load_model('ishop_address_model');
		$address = $address_db->delete(array('username'=>$this->_username, 'id'=>$id));
		showmessage(L('operation_success'),HTTP_REFERER);
	}	
}
?>
