<?php
defined('IN_PHPCMS') or exit('No permission resources.'); 

pc_base::load_app_func('global');
pc_base::load_sys_class('form', '', 0);
pc_base::load_sys_class('format', '', 0);
	 
class index
{
	function __construct()
	{
		$this->username = param::get_cookie('_username');
		$this->userid = param::get_cookie('_userid');
		//$this->siteid = get_siteid();
		define('SITEID', $this->siteid); 	
	} 
	
	public function init()
	{
		$where = '1 ';

		$pid = intval($_GET['pid']);
		$sid = intval($_GET['sid']);

		$sitemodel_db = pc_base::load_model('sitemodel_model');
		$ishop_model = $sitemodel_db->get_one(array('tablename'=>'ishop'), 'modelid');
		$modelid = $ishop_model['modelid'];
		$cats = getcache('category_ishop_'.$modelid, 'ishop');

		if(!empty($sid))
		{
			$cids[] = $sid;
		}
		elseif(!empty($pid))
		{
			$arrchildid = !empty($cats[$pid]['arrchildid']) ? $cats[$pid]['arrchildid'] : '';
			$cids = !empty($arrchildid) ? explode(',', $arrchildid) : array($pid);
		}

		if(!empty($cids))
		{
			$where .= " and cid IN (".implode(',', $cids).") ";
		}

		$size  = 10;
		$product_db = pc_base::load_model("ishop_product_model");
		$count = $product_db->get_one($where, 'count(*) as num ', '');
		$total = $count['num'];
		$page  = max($_GET['page'], 1);
		$infos = $product_db->select($where, '*', ($page-1)*$size.', '.$size, 'updatetime desc'); 
		$pages = pages($total, $page, $size);
		
		$unit = get_unit();
		$this->setting['seo_title'] = $cat_setting['meta_title'] ? $cat_setting['meta_title'] : ($model_setting['meta_title'] ? $model_setting['meta_title'] : $this->setting['seo_title']);
		include template('ishop','index_init');
	}
	
	public function view()
	{
		$pid = intval($_GET['id']);
		$product_db = pc_base::load_model("ishop_product_model");
		$info = $product_db->get_one(array('pid'=>$pid)); 
		$title = $info['name'];
		$unit = get_unit();
		
		$sitemodel_db = pc_base::load_model('sitemodel_model');
		$ishop_model = $sitemodel_db->get_one(array('tablename'=>'ishop'), 'modelid');
		$modelid = $ishop_model['modelid'];
		$categorys = getcache('category_ishop_'.$modelid, 'ishop');
		foreach($categorys as $key=>$val){
			$cats[$key]=$val['catname'];   
		}
		
		include template('ishop', 'index_view');
	}
	
	// 像购物车插入数据
	public function buycar()
	{
		$pid = intval($_GET['id']);
		if (!$pid) {
			exit('1');
		}
		$product_db = pc_base::load_model('ishop_product_model');
		$r = $product_db->get_one(array('pid'=>$pid), 'pid, name, pic, price, num, isfree, isvirtual');
		if(empty($r))
		{
			exit('1');
		}
		if($r['num'] <= 0)
		{
			exit('2');
		}
		
		$userid = param::get_cookie('_userid');
		$prov_userid = param::get_cookie('prov_userid');
		if ($userid) $this->tidy_buycar($userid); //整理购物车
		$prov_userid = intval($prov_userid);
		if (!$userid && !$prov_userid) {
			$prov_userid = intval(mt_rand(1, 16777214));
			param::set_cookie('prov_userid', $prov_userid);
		}
		$buycar_db = pc_base::load_model('ishop_car_model');
		$exceed_time = SYS_TIME-3600*24;
		$sql = "`userid`=0 AND `prov_userid`>0 AND `addtime`<$exceed_time";
		$buycar_db->delete($sql);
		if ($userid) {
			if ($buycar_db->get_one(array('userid'=>$userid, 'status'=>0, 'pid'=>$pid))) {
				exit('3');
			} else {
				$data = array(
							'userid' => $userid,
							'pid'    => $pid,
							'quantity'=>1,
							'price' => $r['price'],
							'name' => $r['name'],
							'thumb' => $r['pic'],
							'isfree' => $r['isfree'],
							'isvirtual' => $r['isvirtual'],
							'addtime' => SYS_TIME,
						);
				$buycar_db->insert($data);
			}
			$res = $buycar_db->get_one(array('userid'=>$userid, 'status'=>0), 'COUNT(id) AS num, SUM(price*quantity) AS total');
		} elseif($prov_userid) {
			if ($buycar_db->get_one(array('prov_userid'=>$prov_userid, 'pid'=>$pid))) {
				exit('3');
			} else {
				$data = array(
							'prov_userid' => $prov_userid,
							'pid'    => $pid,
							'price' => $r['price'],
							'quantity' => 1,
							//'uid' => $r['userid'],
							'name' => $r['name'],
							'thumb' => $r['pic'],
							'isfree' => $r['isfree'],
							'isvirtual' => $r['isvirtual'],
							'addtime' => SYS_TIME,
						);
				$buycar_db->insert($data);
			}
			$res = $buycar_db->get_one(array('prov_userid'=>$prov_userid), 'COUNT(id) AS num, SUM(price*quantity) AS total');
		}
		exit(json_encode($res)); 
	}

	//整理购物车
	public function tidy_buycar($userid)
	{
		$userid = intval($userid);
		$prov_userid = param::get_cookie('prov_userid');
		if (!$userid || !$prov_userid) return false;
		
		$buycar_db = pc_base::load_model('ishop_car_model');
		$result = $buycar_db->select(array('prov_userid'=>$prov_userid), 'id, pid, status');
		if (is_array($result) && !empty($result)) 
		{
			foreach ($result as $r) 
			{
				if ($buycar_db->get_one(array('userid'=>$userid, 'pid'=>$r['pid'], 'status'=>0))) 
				{
					$buycar_db->delete(array('id'=>$r['id']));
				} 
				else 
				{				   
				   $buycar_db->update(array('userid'=>$userid, 'prov_userid'=>0), array('id'=>$r['id']));				   
				}
			}
		}
		param::set_cookie('prov_userid', '');
		return true;
	}

	public function buycar_list()
	{
		$userid = param::get_cookie('_userid');
		$buycar_db = pc_base::load_model('ishop_car_model');
		if ($userid) $this->tidy_buycar($userid); //整理购物车
		if (!$userid) {
			$prov_userid = param::get_cookie('prov_userid');
			if(!$prov_userid) {
				$prov_userid = intval(mt_rand(1, 16777214));
				param::set_cookie('prov_userid', $prov_userid);
				showmessage(L('ishopping_cart_empty'), APP_PATH);
			}
			$products = $buycar_db->select(array('prov_userid'=>$prov_userid));
		} else {
			$products = $buycar_db->select(array('userid'=>$userid, 'status'=>'0'));
		}
		if (empty($products)) {
			showmessage(L('ishopping_cart_empty'), APP_PATH . 'index.php?m=ishop');
		}
		//seo
		// $siteid = get_siteid();
		// $SEO = seo($siteid, '', L('my_cart'));
		include template('ishop', 'index_car_list');
	}

	public function get_buycar()
	{
		$userid = param::get_cookie('_userid');
		if ($userid) $this->tidy_buycar($userid); //整理购物车
		$buycar_db = pc_base::load_model('ishop_car_model');
		//购物车中商品的数量添加、减少、删除操作
		if (isset($_GET['action']) && in_array($_GET['action'], array('-', '+', 'delete'))) {
			$id = intval($_GET['id']);
			if (!$id) exit('1');
			if ($_GET['action']=='-') {
				$buycar_db->update(array('quantity'=>'-=1'), array('id'=>$id));
			} elseif ($_GET['action']=='+') {
				//检查数量不能超过库
				$r = $buycar_db->get_one(array('id'=>$id));

				$product_db = pc_base::load_model('ishop_product_model');
				$info = $product_db->get_one(array('pid'=>$r['pid']));

				if(empty($info)) exit('1');
				if($r['quantity'] + 1 > $info['num']) exit('2');

				$buycar_db->update(array('quantity'=>'+=1'), array('id'=>$id));
			} else {
				$buycar_db->delete(array('id'=>$id));
			}
		}
		if (isset($_GET['action']) && ($_GET['action']=='set')) {
			$quantity = intval($_GET['quantity']);
			$id = intval($_GET['id']);
			if (!$id) exit('1');
			if ($quantity>0) {

				//检查数量不能超过库
				$r = $buycar_db->get_one(array('id'=>$id));

				$product_db = pc_base::load_model('ishop_product_model');
				$info = $product_db->get_one(array('pid'=>$r['pid']));

				if(empty($info)) exit('1');
				if($r['quantity'] + 1 > $info['num']) exit('2');

				$buycar_db->update(array('quantity'=>$quantity), array('id'=>$id));
			} else {
				exit('1');
			}
		}

		if (!$userid) {
			$prov_userid = param::get_cookie('prov_userid');
			if(!$prov_userid) {
				$prov_userid = intval(mt_rand(1, 16777214));
				param::set_cookie('prov_userid', $prov_userid);
			}
				$res = $buycar_db->get_one(array('prov_userid'=>$prov_userid), 'COUNT(id) AS num, SUM(price*quantity) AS total');
			} else {
				$res = $buycar_db->get_one(array('userid'=>$userid, 'status'=>0), 'COUNT(id) AS num, SUM(price*quantity) AS total');
			}
		exit(json_encode($res));  
	}
	
	public function orderinfo()
	{
		$userid = param::get_cookie('_userid');
		if (!$userid) showmessage(L('login_website'), APP_PATH.'index.php?m=member&c=index&a=login&forward='.urlencode($_SERVER["REQUEST_URI"]));
		$this->tidy_buycar($userid); //整理购物车
		$member_address = pc_base::load_model('member_address_model');
		$address = $member_address->get_one(array('userid'=>$userid));
		$buycar_db = pc_base::load_model('ishop_car_model');
		$products = $buycar_db->select(array('userid'=>$userid, 'status'=>'0'));
		$member_db = pc_base::load_model('member_model');
		$memberinfo = $member_db->get_one(array('userid'=>$userid), 'amount');
		$amounts = $memberinfo['amount'];

		//取出省份
		$linkage_db = pc_base::load_model('linkage_model');
		$province_list = array_to($linkage_db->select("parentid=0 and keyid=1", 'linkageid, name'), 'linkageid', 'name');

		$shipping_need = false; //是否需要物流
		if(!empty($products))
		{
			foreach($products as $k=>$v)
			{
				if($v['isvirtual'] == 0){$shipping_need = true; break;}
			}
		}

		if($shipping_need)
		{
			//取出物流
			$shipping_db = pc_base::load_model('ishop_shipping_model');
			$shipping_list = $shipping_db->select(array('enabled'=>1));
			if(!empty($shipping_list))
			{
				foreach($shipping_list as $k=>$v)
				{
					$shipping_list[$k]['shipping_config'] = string2array($v['shipping_config']);
				}
			}
		}

		//seo
		$siteid = get_siteid();
		$SEO = seo($siteid, '', L('order_information'));
		include template('ishop', 'orderinfo'); 
	}

	public function pay()
	{
		$userid = param::get_cookie('_userid');
		$username = param::get_cookie('_username');
		
		if (!$userid) showmessage(L('login_website'), APP_PATH.'index.php?m=member&c=index&a=login&forward='.urlencode($_SERVER["REQUEST_URI"]));

		//判断是否设置收货地址
		$member_address = pc_base::load_model('member_address_model');
		$buyerinfo = $member_address->get_one(array('userid'=>$userid));
		if (!$buyerinfo) 
		{
			showmessage(L('fill_out_receipt_information'), APP_PATH.'index.php?m=ishop&c=index&a=orderinfo');
		}

		//取用户金额 
		$member_db = pc_base::load_model('member_model');
		$memberinfo = $member_db->get_one(array('userid'=>$userid), 'amount');
		$amounts = $memberinfo['amount'];

		//支付信息
		$buycar_db = pc_base::load_model('ishop_car_model');
		$result = $buycar_db->select(array('userid'=>$userid, 'status'=>0));
		if (is_array($result) && !empty($result)) 
		{
			$fee = 0;
			$shipping_need = false; //是否需要物流
			if(!empty($result))
			{
				foreach($result as $k=>$v)
				{
					if($v['isvirtual'] == 0){$shipping_need = true; break;}
				}
			}

			if($shipping_need)
			{
				$shipping_id = intval($_POST['shipping_id']);
				if (!$buyerinfo) 
				{
					showmessage(L('shipping_must_select'), APP_PATH.'index.php?m=ishop&c=index&a=orderinfo');
				}

				pc_base::load_app_class('shipping');
				$fee = shipping::carFee($userid, $shipping_id);
			}

			//商品
			$orders = $error_uid = array();
			$username = param::get_cookie('_username');

			$orders = array(
					'userid'      => $userid,
					'username'    => $username,						
					'truename'	=> trim($buyerinfo['truename']),
					'province_id'	=> intval($buyerinfo['province_id']),
					'province'	=> trim($buyerinfo['province']),
					'address'	=> trim($buyerinfo['address']),
					'tel'		=> $buyerinfo['telephone'] ? trim($buyerinfo['telephone']) : trim($buyerinfo['mobile']),
					'email'       => trim($buyerinfo['email']),
					'code'       => trim($buyerinfo['code']),
					'addtime'      => SYS_TIME,
					'ip'           => ip(),
					'order_sn'     => create_transaction_code(),
			);

			if(count($result)==1)
			{
				$orders['buycarid']	= $result[0]['id'];
				$orders['money']	= trim(floatval($result[0]['price']))*intval($result[0]['quantity']);
				$orders['content']	= $username.L('ishops_buy_goods').$result[0]['name'];
				$orders['quantity']	= intval($result[0]['quantity']);					
		
			}
			else
			{
				foreach ($result as $k=>$r) 
				{
					$orders['buycarid'] .= (!empty($orders['buycarid'])?',':'').$r['id'];
					$orders['money']	+= trim(floatval($r['price']))*intval($r['quantity']);					
					$orders['content']	.= (!empty($orders['content'])?'、':'').$r['name'];
					$orders['quantity'] += intval($r['quantity']);					
				}
			}

			$orders['discount'] = 0;
			$orders['fee'] = $fee;
			if($shipping_need)
			{
				$orders['shipping_id'] = $shipping_id;
			}
			else
			{
				$orders['shipping_id'] = 0;
			}	
			
			$orders['total'] = $orders['money'] + $orders['fee'] + $orders['discount'];

			if($orders['total'] > $amounts)
			{
				showmessage(L('not_enough_month'), APP_PATH.'index.php?m=ishop&c=index&a=orderinfo');
			}

			$o			= pc_base::load_app_class('orders'); 
			$product_db = pc_base::load_model('ishop_product_model');

			//标记购物车该项记录已被结算
			$o->add_record($orders);
			$buycar_db->update(array('status'=>1), '`id` IN('.$orders['buycarid'].')');

			//产品数量修改
			foreach ($result as $k=>$r) 
			{
				$product_db->update(array('num'=>'-='.$r['quantity']), array('pid'=>$r['pid']));
			}

			//扣除金钱
			//加入消费记录，同时扣除金钱
			pc_base::load_app_class('spend', 'pay', 0);
			spend::amount($orders['money'] + $orders['fee'], L('ishop_buy'), $userid, $username);

			showmessage(L('operation_success'), APP_PATH.'index.php?m=ishop');
		} 
		exit;
	}
	
	//ajax修改用户收货地址
	public function changeaddress() 
	{
		$userid = param::get_cookie('_userid');
		if (!$userid) exit('1');
		$info['truename'] = $_GET['name'] ? $_GET['name'] : exit('2');
		$info['province_id'] = $_GET['province_id'] ? $_GET['province_id'] : exit('2');
		$info['province'] = $_GET['province'] ? $_GET['province'] : exit('2');
		$info['address'] = $_GET['address'] ? $_GET['address'] : exit('3');
		$info['mobile'] = $_GET['mobile'];
		$info['telephone'] = $_GET['telephone'];
		if (!$info['mobile'] && !$info['telephone']) exit('4');
		$info['email'] = $_GET['email'];
		$info['code'] = $_GET['code'];
		$member_address = pc_base::load_model('member_address_model');
		$info = array_iconv($info, 'UTF-8', CHARSET);
		if ($member_address->get_one(array('userid'=>$userid))) {
			$member_address->update($info, array('userid'=>$userid));
		} else {
			$info['userid'] = $userid;
			$member_address->insert($info);
		}
		exit('5');
	}

	public function get_member_address() 
	{
		$userid = param::get_cookie('_userid');
		if (!$userid) exit('0');
		$member_address = pc_base::load_model('member_address_model');
		if ($member_address->get_one(array('userid'=>$userid))) {
			exit('1');
		} else {
			exit('0');
		}
	}

	//取购物车的运费
	public function get_shipping_fee()
	{
		$shipping_id = intval($_GET['shipping_id']);

		pc_base::load_app_class('shipping');
		$fee = shipping::carFee($this->userid, $shipping_id);
		exit(json_encode(array('success'=>1, 'fee'=>$fee)));
	}
}
?>
