
DROP TABLE IF EXISTS `phpcms_ishop_orders`;
CREATE TABLE `phpcms_ishop_orders` (
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT COMMENT '订单号',
  `buycarid` varchar(50) CHARACTER SET latin1 NOT NULL COMMENT '商品id',
  `status` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '0未发货 1发货中 2已完成',
  `userid` mediumint(8) NOT NULL,
  `username` char(50) NOT NULL COMMENT '用户id',
  `truename` varchar(20) NOT NULL,
  `province_id` int(10) unsigned NOT NULL DEFAULT '0' COMMENT '省份id',
  `province` char(40) NOT NULL COMMENT '省份',
  `address` char(255) NOT NULL,
  `tel` char(15) NOT NULL,
  `email` char(40) NOT NULL,
  `code` char(15) NOT NULL,
  `order_sn` char(50) NOT NULL,
  `shipping_id` mediumint(8) DEFAULT '0' COMMENT '物流',
  `total` decimal(8,2) unsigned NOT NULL DEFAULT '0.00' COMMENT '总额(discount+money+fee)',
  `discount` decimal(8,2) NOT NULL,
  `money` decimal(8,2) unsigned NOT NULL,
  `fee` decimal(8,2) unsigned NOT NULL DEFAULT '0.00' COMMENT '运费',
  `ip` char(20) NOT NULL,
  `content` tinytext NOT NULL COMMENT '物品',
  `quantity` int(8) NOT NULL DEFAULT '1',
  `usernote` text NOT NULL,
  `delivertime` int(10) unsigned NOT NULL COMMENT '送货时间',
  `addtime` int(10) unsigned NOT NULL COMMENT '提交时间',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=1 DEFAULT CHARSET=utf8;

-- ----------------------------
-- Records of phpcms_ishop_orders
-- ----------------------------
INSERT INTO `phpcms_ishop_orders` VALUES ('1', '1,2', '0', '1', 'test', '陈国仁', '2', '北京市', '招时区', '15959010205', 'fire@163.com', '350001', '2015061217042081038', '11', '172.00', '0.00', '151.00', '21.00', '127.0.0.1', '一公斤物品、两公斤物品', '2', '', '0', '1434099860');
