
DROP TABLE IF EXISTS `phpcms_ishop_product`;
CREATE TABLE `phpcms_ishop_product` (
  `pid` int(10) unsigned NOT NULL AUTO_INCREMENT COMMENT '商品id',
  `no1` varchar(155) NOT NULL,
  `name` varchar(255) NOT NULL DEFAULT '' COMMENT '产品名称',
  `cid` smallint(5) unsigned NOT NULL COMMENT '类别id',
  `spe` char(125) NOT NULL COMMENT '产品规格',
  `unit` tinyint(5) unsigned NOT NULL DEFAULT '1' COMMENT '产品单位',
  `price` decimal(8,2) unsigned NOT NULL COMMENT '产品价格',
  `pic` varchar(255) NOT NULL COMMENT '产品图片',
  `num` int(8) unsigned NOT NULL COMMENT '产品数量',
  `content` mediumtext NOT NULL COMMENT '描述',
  `isfree` tinyint(3) DEFAULT '0' COMMENT '是否是免运费',
  `isvirtual` tinyint(3) DEFAULT '0' COMMENT '是否是虚拟物品',
  `addtime` int(10) unsigned NOT NULL,
  `updatetime` int(10) unsigned NOT NULL,
  PRIMARY KEY (`pid`)
) ENGINE=MyISAM AUTO_INCREMENT=1 DEFAULT CHARSET=utf8;

-- ----------------------------
-- Records of phpcms_ishop_product
-- ----------------------------
INSERT INTO `phpcms_ishop_product` VALUES ('1', '', '一公斤物品', '16', '1', '1', '101.00', '', '89', 'dfasdfdfs', '0', '0', '1433750055', '1433750055');
INSERT INTO `phpcms_ishop_product` VALUES ('2', '', '两公斤物品', '17', '2', '1', '50.00', '', '88', '10101', '0', '0', '1433757450', '1433757450');
