<?php
defined('IN_PHPCMS') or exit('No permission resources.');

pc_base::load_app_class('admin', 'admin', 0);
pc_base::load_sys_class('form', 0, 0);
pc_base::load_app_func('global');
 
class order extends admin
{
	private $db;
	public function __construct()
	{
		$this->db = pc_base::load_model('ishop_orders_model');
		parent::__construct();		
	}

	/**
	* 订单列表
	*/
	public function manage()
	{   
		$where = '1 ';
		if($_GET['type']){
			if($_GET['type'] == 1){
				$where .= " and id = '".$_GET['q']."'";
			}else{
				$where .= " and username = '%".$_GET['q']."%'";
			}    
		}
		if($_GET['start_addtime']){
			$where .= " and addtime >= '".strtotime($_GET['start_addtime'])."'";   
		}
		if($_GET['end_addtime']){
			$where .= " and addtime <= '".strtotime($_GET['end_addtime'])."'";
		} 
		
		$size = 20;
		$count = $this->db->get_one($where, 'count(id) as num ', '');
		$total = $count['num'];
		$page = max($_GET['page'], 1);
		$infos = $this->db->select($where, '*', ($page-1)*$size.', '.$size, 'addtime desc');
		foreach($infos as $k=>$v){
			$infos[$k]['pics'] = getProductPic($v['pids']);   
		}
		 
		$pages = pages($total, $page, $size);
		
		$sitemodel_db = pc_base::load_model('sitemodel_model');
		$ishop_model = $sitemodel_db->get_one(array('tablename'=>'ishop'), 'modelid');
		$modelid = $ishop_model['modelid'];
		$categorys = getcache('category_ishop_'.$modelid, 'ishop');
		foreach($categorys as $key=>$val){
			$cats[$key]=$val['catname'];   
		}
		include $this->admin_tpl('order_manage');  
	}    
	public function public_view_order()
	{   
		if($_POST['dosubmit']){
			$status = intval($_POST['status']); 
			$id = intval($_POST['id']); 
			$this->db->update(array('status'=>$status), "id='{$id}'"); 
			showmessage(L('update_success'), HTTP_REFERER, '', 'view');
		}else{
			$id		= intval($_GET['id']);
			$o		= pc_base::load_app_class('orders');
			$info	= $o->get($id);
			$show_header = false;
			include $this->admin_tpl("order_view"); 
		}
		
	}
	public function public_update_status()
	{
		if($_POST['dosubmit']){
			$status = intval($_POST['status']); 
			$id = intval($_POST['id']); 
			$this->db->update(array('status'=>$status), "id='{$id}'"); 
			showmessage(L('update_success'), HTTP_REFERER, '', 'view');
		}else{
			$id = intval($_GET['id']);
			$info = $this->db->get_one(array('id'=>$id), 'status');
			include $this->admin_tpl('order_status');    
		}  
	}
   
   public function delete()
   {
		if(!$_GET['id'])die();
		$id = intval($_GET['id']);
		$ids = $this->db->get_one(array('id'=>$id), 'buycarid');
		$car_db = pc_base::load_model('ishop_car_model');
		$ids = explode(',', $ids['buycarid']);
		foreach($ids as $pid){
			$car_db->delete(array('id'=>$pid));
		}
		$this->db->delete(array('id'=>$id));
		showmessage(L('operation_success'),HTTP_REFERER);  
   }
   
   public function delete_all()
   {
		showmessage(L('operation_success'),HTTP_REFERER);
   }
	
}
?>
