<?php
defined('IN_PHPCMS') or exit('No permission resources.');

pc_base::load_app_class('admin', 'admin', 0);
pc_base::load_sys_class('form', 0, 0);
pc_base::load_app_func('global');
 
class product  extends admin
{
	private $db;
	public function __construct()
	{
		$this->db = pc_base::load_model('ishop_product_model');
		parent::__construct();		
	}
	public function product()
	{
	}

	//商品列表
	public function slist()
	{    
		$where = '1 ';
		if($_GET['type'] && !empty($_GET['q']))
		{
			if($_GET['type'] == 1)
			{
				$where .= " and pid = '".productNoDecode($_GET['q'])."'";
			}
			else
			{
				$where .= " and name = '%".$_GET['q']."%'";
			}    
		}

		if($_GET['start_addtime']){
			$where .= " and addtime >= '".strtotime($_GET['start_addtime'])."'";   
		}
		if($_GET['end_addtime']){
			$where .= " and addtime <= '".strtotime($_GET['end_addtime'])."'";
		}
		$size = 20;
		$count = $this->db->get_one($where, 'count(pid) as num ', '');
		$total = $count['num'];
		$page = max($_GET['page'], 1);
		$infos = $this->db->select($where, '*', ($page-1)*$size.', '.$size, 'updatetime desc'); 
		$pages = pages($total, $page, $size);
		
		$sitemodel_db = pc_base::load_model('sitemodel_model');
		$ishop_model = $sitemodel_db->get_one(array('tablename'=>'ishop'), 'modelid');
		$modelid = $ishop_model['modelid'];
		$categorys = getcache('category_ishop_'.$modelid, 'ishop');
		foreach($categorys as $key=>$val){
			$cats[$key]=$val['catname'];   
		}
		$unit = get_unit(); 
		$big_menu = array('javascript:window.top.art.dialog({id:\'add\',iframe:\'?m=ishop&c=product&a=add\', title:\''.L('ishop_add').'\', width:\'900\', height:\'500\', lock:true}, function(){var d = window.top.art.dialog({id:\'add\'}).data.iframe;var form = d.document.getElementById(\'dosubmit\');form.click();return false;}, function(){window.top.art.dialog({id:\'add\'}).close()});void(0);', L('ishop_add'));
		include $this->admin_tpl('product_list');
	}    

	public function public_check_no1()
	{   
		if(!$_GET['no1']) {echo 0;exit;};
		$no1 = $_GET['no1'];
		$r = $this->db->get_one("no1='".$no1."'",'pid');
		if($r['pid'] && $_GET['pid'] && $r['pid']==$_GET['pid']){
			echo 1;exit; 
		}else{
			echo $r['pid']? 0 : 1; exit;  
		}
	}

	//添加商品
	public function add()
	{
		if(isset($_POST['dosubmit'])){
			$info = $_POST['ishop'];
			$info['addtime'] = $info['updatetime'] = time();
			$this->db->insert($info, true);    
			if($this->db->insert_id()){
				showmessage(L('add_success'), HTTP_REFERER, '', 'add');
			}else{
				showmessage(L('add_failure'), HTTP_REFERER, '', 'add');
			}  			
		}
		else
		{
			$sitemodel_db = pc_base::load_model('sitemodel_model');
			$ishop_model = $sitemodel_db->get_one(array('tablename'=>'ishop'), 'modelid');
			$modelid = $ishop_model['modelid'];
			include $this->admin_tpl('product_add');
		}
	}

	public function edit()
	{
		if($_POST['dosubmit'])
		{
			$return_url = $_POST['url'];
			$pid = intval($_POST['pid']);
			$info = $_POST['ishop'];
			//$info['isfree'] = isset($info['isfree']) ? 1 : 0;
			$info['isvirtual'] = isset($info['isvirtual']) ? 1 : 0;
			$this->db->update($info, array('pid' =>$pid));
			showmessage(L('update_success'), HTTP_REFERER, '', 'edit');
		}
		else
		{ 
			if(isset($_GET['pid']))
			{
				$pid = intval($_GET['pid']);
				$info = $this->db->get_one('pid='.$pid);
				
				$sitemodel_db = pc_base::load_model('sitemodel_model');
				$ishop_model = $sitemodel_db->get_one(array('tablename'=>'ishop'), 'modelid');
				$modelid = $ishop_model['modelid'];
				include $this->admin_tpl('product_edit');				
			}
			else
			{
				showmessage('parameters_error');
			}
		}   
	}
	
	public function delete()
	{   
		if(!$_GET['pid'])die();
		$pid = intval($_GET['pid']);
		$this->db->delete(array('pid'=>$pid));
		showmessage(L('operation_success'),HTTP_REFERER);  
	}
	
	public function delete_all()
	{
		showmessage(L('operation_success'),HTTP_REFERER);
	}
}
?>
