<?php 
    defined('IN_ADMIN') or exit('No permission resources.');
    include $this->admin_tpl('header','admin');
?>

<div class="pad_10">
	<div class="table-list">

		<table width="100%" cellspacing="0">
			<thead>
				<tr>
					<th align="left" width="60">ID</th>
					<th align="left" width="150"><?php echo L('shipping_name')?></th>
					<th align="center"><?php echo L('shipping_desc')?></th>
					<th align="center" width="100"><?php echo L('shipping_enabled')?></th>
					<th align="left"><?php echo L('operations_manage')?></th>
				</tr>
			</thead>
			<tbody>
				 <?php 
				if(is_array($lists)){
					foreach($lists as $info){
				?>   
					<tr>
						<td align="left"><?php echo $info['shipping_id']?></td>
						<td align="left"><?php echo $info['shipping_name']?></td>
						<td align="left"><?php echo $info['shipping_desc']?></td>
						<td align="center"><?php echo $info['enabled'] ? '√' : '×'?></td>
						<td align="left">
							<a href="index.php?m=ishop&c=shipping&a=change_enabled&id=<?php echo $info['shipping_id']?>"><?php echo L('shipping_change_enabled')?></a> | 
							<a href="javascript:void(0);" onclick="edit('<?php echo $info['shipping_id']?>')"><?php echo L('set')?></a> | 
							<a href="javascript:void(0);" onclick="del('<?php echo $info['shipping_id']?>')"><?php echo L('delete');?></a> 	
						</td>
					</tr>
				<?php 
					}
				}
				?>
			</tbody>
		</table>
	</div>
	<div id="pages"><?php echo $pages;?></div>
</div>

</body>
</html>
<script type="text/javascript">

function edit(id) 
{
	window.top.art.dialog(
		{
			id:'edit',
			iframe:'?m=ishop&c=shipping&a=edit&id='+id, 
			title:'<?php echo L('shipping_edit')?>', 
			width:'900', 
			height:'500', 
			lock:true
		}, 
		function(){
				var d = window.top.art.dialog({id:'edit'}).data.iframe;
				var form = d.document.getElementById('dosubmit');form.click();return false;
		}, 
		function(){
			window.top.art.dialog({id:'edit'}).close()
		}
	);
	void(0);
}

function del(id)
{
    if(confirm('确认删除吗？'))
	{
		location.href="index.php?m=ishop&c=shipping&a=del&id="+id+"&pc_hash="+pc_hash;
	}
}

</script>