<?php 
defined('IN_ADMIN') or exit('No permission resources.');
include $this->admin_tpl('header', 'admin');
?>

<style>
.table_form tbody td, .table_form tbody th {
  border-bottom: 0px solid #eee;
}
.table_form td, .table_form th {
  padding: 10px 0 4px 8px;
}
</style>

<div class="pad-10">
	<form method="post" action="?m=ishop&c=shipping&a=<?php echo $info['shipping_id'] ? 'edit' : 'add'?>" name="myform" id="myform">
		<fieldset>
		<table class="table_form" width="100%" cellspacing="0">
		<tbody>
			<tr>
				<td colspan="7">
					<strong><?php echo L('shipping_name')?>：</strong>
					<input name="shipping_name" class="input-text" value="<?php echo $info['shipping_name']?>" type="text" style="width: 200px" >
				</td>		
			</tr>
			<tr>
				<td colspan="7">
					<strong><?php echo L('shipping_desc')?>：</strong>
					<input name="shipping_desc" class="input-text" value="<?php echo $info['shipping_desc']?>" type="text" style="width: 600px" >
				</td>		
			</tr>

			<tr>
				<td><strong><?php echo L('shipping_mode')?></strong></td>
				<td><strong><?php echo L('shipping_base_fee')?></strong></td>
				<td><strong><?php echo L('shipping_weight_first')?></strong></td>
				<td><strong><?php echo L('shipping_weight_step')?></strong></td>
				<td><strong><?php echo L('shipping_weight_step_fee')?></strong></td>
				<td><strong><?php echo L('shipping_number_one_fee')?></strong></td>
				<td><strong><?php echo L('shipping_money_fee')?></strong></td>				
			</tr>

			<tr>	
				<td style="display: none"></td>
				<td><div><?php echo form::select(get_shipping_mode(), $info['shipping_mode'], 'name="shipping_mode" class="shipping_mode"')?></div></td>
				<td><div><input name="shipping_base_fee" id="shipping_base_fee" class="input-text" value="<?php echo $info['shipping_base_fee']?>" type="text" style="width: 80px" ></div></td>
				<td><div><input name="shipping_weight_first" id="shipping_weight_first" class="input-text" value="<?php echo $info['shipping_weight_first']?>" type="text" style="width: 80px" ></div></td>
				<td><div><input name="shipping_weight_step" id="shipping_weight_step" class="input-text" value="<?php echo $info['shipping_weight_step']?>" type="text" style="width: 80px" ></div></td>
				<td><div><input name="shipping_weight_step_fee" id="shipping_weight_step_fee" class="input-text" value="<?php echo $info['shipping_weight_step_fee']?>" type="text" style="width: 80px" ></div></td>
				<td><div><input name="shipping_number_one_fee" id="shipping_number_one_fee" class="input-text" value="<?php echo $info['shipping_number_one_fee']?>" type="text" style="width: 80px" ></div></td>
				<td><div><input name="shipping_money_fee" id="shipping_money_fee" class="input-text" value="<?php echo $info['shipping_money_fee']?>" type="text" style="width: 80px" ></div></td>
			</tr>
		</tbody>
		</table>
		</fieldset>

		<div class="clear" style="margin-top: 10px;"></div>
		<fieldset>
		<legend><label>指定区域</label></legend>
		<table class="table_form" width="100%" cellspacing="0">
		<tbody>
			<tr>
				<td colspan="2">
					
						<table width="100%"  class="table_form">
							<tr>
								<td width="80"><strong><?php echo L('province')?></strong></td>
								<td><strong><?php echo L('shipping_mode')?></strong></td>
								<td><strong><?php echo L('shipping_base_fee')?></strong></td>
								<td><strong><?php echo L('shipping_weight_first')?></strong></td>
								<td><strong><?php echo L('shipping_weight_step')?></strong></td>
								<td><strong><?php echo L('shipping_weight_step_fee')?></strong></td>
								<td><strong><?php echo L('shipping_number_one_fee')?></strong></td>
								<td><strong><?php echo L('shipping_money_fee')?></strong></td>				
							</tr>

							<?php if(!empty($info['shipping_config'])) foreach($info['shipping_config'] as $k=>$v){?>
								<tr>
									<td><div><input name="shipping_config[<?php echo $k?>][province_name]" value="<?php echo $v['province_name']?>" type="hidden"><b><?php echo $v['province_name']?></b></div></td>
									<td><div><?php echo form::select(get_shipping_mode(), $v['shipping_mode'], 'name="shipping_config['.$k.'][shipping_mode]" class="shipping_mode"')?></div></td>
									<td><div><input name="shipping_config[<?php echo $k?>][shipping_base_fee]" class="input-text" value="<?php echo $v['shipping_base_fee']?>" type="text" style="width: 60px" ></div></td>
									<td><div><input name="shipping_config[<?php echo $k?>][shipping_weight_first]" class="input-text" value="<?php echo $v['shipping_weight_first']?>" type="text" style="width: 60px" ></div></td>
									<td><div><input name="shipping_config[<?php echo $k?>][shipping_weight_step]" class="input-text" value="<?php echo $v['shipping_weight_step']?>" type="text" style="width: 60px" ></div></td>
									<td><div><input name="shipping_config[<?php echo $k?>][shipping_weight_step_fee]" class="input-text" value="<?php echo $v['shipping_weight_step_fee']?>" type="text" style="width: 60px" ></div></td>
									<td><div><input name="shipping_config[<?php echo $k?>][shipping_number_one_fee]" class="input-text" value="<?php echo $v['shipping_number_one_fee']?>" type="text" style="width: 60px" ></div></td>
									<td><div><input name="shipping_config[<?php echo $k?>][shipping_money_fee]" class="input-text" value="<?php echo $v['shipping_money_fee']?>" type="text" style="width: 60px" ></div></td>
								</tr>
							<?php }?>

							<tr>
								<td colspan="7">
									<a href="javascript:void(0)" style="text-decoration:none;" onclick="shipping_area(this, '<?php echo $key?>')"><img src="<?php echo IMG_PATH?>admin_img/plus.gif"> 为指定地区设置运费</a>
								</td>
							</tr>
						</table>
					
				</td>
			</tr>
		</tbody>
		</table>
		</fieldset>
		<input type="hidden" name="id" value="<?php echo intval($info['shipping_id'])?>" >
		<input type="submit" name="dosubmit" id="dosubmit" value=" <?php echo L('ok')?> " class="dialog">&nbsp;
		<input type="reset" class="dialog" value=" <?php echo L('clear')?> ">
	</form>
</div>

<style>
	.show-buycar{background-color:#fff;border: 1px solid #CCC;height: 200px;position: absolute;width: 500px;z-index: 5; padding:8px 10px; color:#333; display: none; z-index:50}
	.show-buycar .title{ border-bottom:1px solid #EAEAEA; padding-bottom:5px; font-size:14px; margin-bottom:10px}
	.show-buycar .title a.close{background:#fff url(<?php echo IMG_PATH?>cross.png) no-repeat left 5px; padding-left:18px;outline:none; display:block; float:right; font-size:12px; height:18px; padding-top:1px}
	.show-buycar .title a.close:hover{background-position: left -45px; text-decoration:none}
	.show-buycar .content{padding:10px 0 0 20px}
	.show-buycar .content .bottom{ margin-top:12px}
</style>
<div class="show-buycar" id="show-buycar">
	<input type="hidden" id="key" value="" />
    <div class="title"><a href="javascript:;" onclick="$('.show-buycar').hide();" class="close">关闭</a><strong>提示</strong></div>
    <div class="content">
		<?php echo form::checkbox($province_list, 0, 'name="province[]"', '', 80, 'province_id')?>
		<p class="bottom"><input type="button" class="button" value=" 确认 " onclick="shipping_area_add()"></p>		
    </div>
</div>

</body>
</html>
<script type="text/javascript">

	var target = false;
	function shipping_area(obj, key)
	{
		target = obj;
		$("#key").val(key);
		var os = $(obj);
		var showBuycar=$(".show-buycar"),offset =os.offset();
		showBuycar.hide();
		showBuycar.css({"position":"absolute","z-index":"100",left:offset.left,top:offset.top+20});
		showBuycar.show();
		return;
	}
	function shipping_area_add()
	{
		var key = $("#key").val();
		$.each($("input[name='province[]']:checked"), function(i, e){
			var province_id   = $(e).val();
			var province_name = $(e).parent().html().replace(/<[^>]+>/g,"");
			var html = '\
						<tr>\
							<td><div><input name="shipping_config['+province_id+'][province_name]" value="'+province_name+'" type="hidden"><b>'+province_name+'</b></div></td>\
							<td><div><?php echo form::select(get_shipping_mode(), 'number', 'name="shipping_config_shipping_mode" class="shipping_mode"')?></div></td>\
							<td><div><input name="shipping_config['+province_id+'][shipping_base_fee]" class="input-text" value="<?php echo $info['shipping_base_fee']?>" type="text" style="width: 60px" ></div></td>\
							<td><div><input name="shipping_config['+province_id+'][shipping_weight_first]" class="input-text" value="<?php echo $info['shipping_weight_first']?>" type="text" style="width: 60px" ></div></td>\
							<td><div><input name="shipping_config['+province_id+'][shipping_weight_step]" class="input-text" value="<?php echo $info['shipping_weight_step']?>" type="text" style="width: 60px" ></div></td>\
							<td><div><input name="shipping_config['+province_id+'][shipping_weight_step_fee]" class="input-text" value="<?php echo $info['shipping_weight_step_fee']?>" type="text" style="width: 60px" ></div></td>\
							<td><div><input name="shipping_config['+province_id+'][shipping_number_one_fee]" class="input-text" value="<?php echo $info['shipping_number_one_fee']?>" type="text" style="width: 60px" ></div></td>\
							<td><div><input name="shipping_config['+province_id+'][shipping_money_fee]" class="input-text" value="<?php echo $info['shipping_money_fee']?>" type="text" style="width: 60px" ></div></td>\
						</tr>\
					';
			html = html.replace('shipping_config_shipping_mode', 'shipping_config['+province_id+'][shipping_mode]');

			$(target).parent().parent().before(html);
			$(".show-buycar").hide();
			shipping_set();
		});
		$("input[name='province[]']:checked").prop('checked', false);
	}
	function shipping_set()
	{
		$(".shipping_mode").each(function(i, e){
			var mode = $(e).val();
			var obj  = $(e).parents('tr').children('td');

			if (mode == 'self')
			{
				obj.eq(2).children('div').eq(0).hide();
				obj.eq(3).children('div').eq(0).hide();
				obj.eq(4).children('div').eq(0).hide();
				obj.eq(5).children('div').eq(0).hide();
				obj.eq(6).children('div').eq(0).hide();
				obj.eq(7).children('div').eq(0).hide();
			}
			else if (mode == 'fixed')
			{
				obj.eq(2).children('div').eq(0).show();
				obj.eq(3).children('div').eq(0).hide();
				obj.eq(4).children('div').eq(0).hide();
				obj.eq(5).children('div').eq(0).hide();
				obj.eq(6).children('div').eq(0).hide();
				obj.eq(7).children('div').eq(0).hide();
			}
			else if (mode == 'weight')
			{
				obj.eq(2).children('div').eq(0).show();
				obj.eq(3).children('div').eq(0).show();
				obj.eq(4).children('div').eq(0).show();
				obj.eq(5).children('div').eq(0).show();
				obj.eq(6).children('div').eq(0).hide();
				obj.eq(7).children('div').eq(0).show();
			}
			else if (mode == 'number')
			{
				obj.eq(2).children('div').eq(0).show();
				obj.eq(3).children('div').eq(0).hide();
				obj.eq(4).children('div').eq(0).hide();
				obj.eq(5).children('div').eq(0).hide();
				obj.eq(6).children('div').eq(0).show();
				obj.eq(7).children('div').eq(0).show();
			}
		});
	}
	$(function(){
		shipping_set();
		$(".shipping_mode").live('change', function() {
			shipping_set();
		});
	});
</script>